Loading...
Searching...
No Matches
Halide::Internal::GeneratorParamBase Class Referenceabstract

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorParamBase:

## Public Member Functions

| GeneratorParamBase (const std::string &name)
virtual | ~GeneratorParamBase ()
const std::string & | name () const
void | set (const std::string &new_value)
void | set (const char *new_value)
| GeneratorParamBase (const GeneratorParamBase &)=delete
GeneratorParamBase & | operator= (const GeneratorParamBase &)=delete
| GeneratorParamBase (GeneratorParamBase &&)=delete
GeneratorParamBase & | operator= (GeneratorParamBase &&)=delete

## Protected Member Functions

void | check_value_readable () const
void | check_value_writable () const
virtual void | set_from_string (const std::string &value_string)=0
virtual std::string | call_to_string (const std::string &v) const =0
virtual std::string | get_c_type () const =0
virtual std::string | get_type_decls () const
virtual std::string | get_default_value () const =0
virtual bool | is_synthetic_param () const
virtual bool | is_looplevel_param () const
void | fail_wrong_type (const char *type)

## Detailed Description

Definition at line 395 of file Generator.h.

## Constructor & Destructor Documentation

## GeneratorParamBase() [1/3]

Halide::Internal::GeneratorParamBase::GeneratorParamBase | ( | const std::string & | name | ) |

explicit

References name().

Referenced by GeneratorParamBase(), GeneratorParamBase(), Halide::Internal::GeneratorParamImpl< T >::GeneratorParamImpl(), operator=(), and operator=().

## ~GeneratorParamBase()

virtual Halide::Internal::GeneratorParamBase::~GeneratorParamBase | ( |  | ) |

virtual

## GeneratorParamBase() [2/3]

Halide::Internal::GeneratorParamBase::GeneratorParamBase | ( | const GeneratorParamBase & |  | ) |

delete

References GeneratorParamBase().

## GeneratorParamBase() [3/3]

Halide::Internal::GeneratorParamBase::GeneratorParamBase | ( | GeneratorParamBase && |  | ) |

delete

References GeneratorParamBase().

## Member Function Documentation

## name()

const std::string & Halide::Internal::GeneratorParamBase::name | ( |  | ) | const

inline

Definition at line 400 of file Generator.h.

Referenced by Halide::Internal::GeneratorParam_Enum< T >::call_to_string(), Halide::Internal::GeneratorParam_Arithmetic< T >::GeneratorParam_Arithmetic(), Halide::Internal::GeneratorParam_Bool< T >::GeneratorParam_Bool(), Halide::Internal::GeneratorParam_Enum< T >::GeneratorParam_Enum(), Halide::Internal::GeneratorParam_LoopLevel::GeneratorParam_LoopLevel(), Halide::Internal::GeneratorParam_String< T >::GeneratorParam_String(), Halide::Internal::GeneratorParam_Target< T >::GeneratorParam_Target(), Halide::Internal::GeneratorParam_Type< T >::GeneratorParam_Type(), GeneratorParamBase(), Halide::Internal::GeneratorParamImpl< T >::GeneratorParamImpl(), Halide::Internal::GeneratorParam_Enum< T >::get_c_type(), Halide::Internal::GeneratorParam_Enum< T >::get_default_value(), Halide::Internal::GeneratorParam_Enum< T >::get_type_decls(), and Halide::Internal::GeneratorParam_LoopLevel::set_from_string().

## set() [1/2]

void Halide::Internal::GeneratorParamBase::set | ( | const std::string & | new_value | ) |

inline

Definition at line 434 of file Generator.h.

References set_from_string().

## set() [2/2]

void Halide::Internal::GeneratorParamBase::set | ( | const char * | new_value | ) |

inline

Definition at line 437 of file Generator.h.

References set_from_string().

## check_value_readable()

void Halide::Internal::GeneratorParamBase::check_value_readable | ( |  | ) | const

protected

Referenced by Halide::Internal::GeneratorParamImpl< T >::value().

## check_value_writable()

void Halide::Internal::GeneratorParamBase::check_value_writable | ( |  | ) | const

protected

Referenced by Halide::Internal::GeneratorParamImpl< T >::set(), and Halide::Internal::GeneratorParamImpl< T >::set_impl().

## set_from_string()

virtual void Halide::Internal::GeneratorParamBase::set_from_string | ( | const std::string & | value_string | ) |

protected pure virtual

Implemented in Halide::Internal::GeneratorParam_Arithmetic< T >, Halide::Internal::GeneratorParam_AutoSchedulerParams, Halide::Internal::GeneratorParam_Bool< T >, Halide::Internal::GeneratorParam_Enum< T >, Halide::Internal::GeneratorParam_LoopLevel, Halide::Internal::GeneratorParam_String< T >, Halide::Internal::GeneratorParam_Synthetic< T >, and Halide::Internal::GeneratorParam_Target< T >.

Referenced by set(), and set().

## call_to_string()

virtual std::string Halide::Internal::GeneratorParamBase::call_to_string | ( | const std::string & | v | ) | const

protected pure virtual

Implemented in Halide::Internal::GeneratorParam_Arithmetic< T >, Halide::Internal::GeneratorParam_AutoSchedulerParams, Halide::Internal::GeneratorParam_Bool< T >, Halide::Internal::GeneratorParam_Enum< T >, Halide::Internal::GeneratorParam_LoopLevel, Halide::Internal::GeneratorParam_String< T >, Halide::Internal::GeneratorParam_Synthetic< T >, Halide::Internal::GeneratorParam_Target< T >, and Halide::Internal::GeneratorParam_Type< T >.

## get_c_type()

virtual std::string Halide::Internal::GeneratorParamBase::get_c_type | ( |  | ) | const

protected pure virtual

Implemented in Halide::Internal::GeneratorParam_Arithmetic< T >, Halide::Internal::GeneratorParam_AutoSchedulerParams, Halide::Internal::GeneratorParam_Bool< T >, Halide::Internal::GeneratorParam_Enum< T >, Halide::Internal::GeneratorParam_LoopLevel, Halide::Internal::GeneratorParam_String< T >, Halide::Internal::GeneratorParam_Synthetic< T >, Halide::Internal::GeneratorParam_Target< T >, and Halide::Internal::GeneratorParam_Type< T >.

## get_type_decls()

virtual std::string Halide::Internal::GeneratorParamBase::get_type_decls | ( |  | ) | const

inline protected virtual

Reimplemented in Halide::Internal::GeneratorParam_Enum< T >, and Halide::Internal::GeneratorParam_Type< T >.

Definition at line 455 of file Generator.h.

## get_default_value()

virtual std::string Halide::Internal::GeneratorParamBase::get_default_value | ( |  | ) | const

protected pure virtual

Implemented in Halide::Internal::GeneratorParam_Arithmetic< T >, Halide::Internal::GeneratorParam_AutoSchedulerParams, Halide::Internal::GeneratorParam_Bool< T >, Halide::Internal::GeneratorParam_Enum< T >, Halide::Internal::GeneratorParam_LoopLevel, Halide::Internal::GeneratorParam_String< T >, Halide::Internal::GeneratorParam_Synthetic< T >, Halide::Internal::GeneratorParam_Target< T >, and Halide::Internal::GeneratorParam_Type< T >.

## is_synthetic_param()

virtual bool Halide::Internal::GeneratorParamBase::is_synthetic_param | ( |  | ) | const

inline protected virtual

Reimplemented in Halide::Internal::GeneratorParam_Synthetic< T >.

Definition at line 461 of file Generator.h.

## is_looplevel_param()

virtual bool Halide::Internal::GeneratorParamBase::is_looplevel_param | ( |  | ) | const

inline protected virtual

Reimplemented in Halide::Internal::GeneratorParam_LoopLevel.

Definition at line 465 of file Generator.h.

## fail_wrong_type()

void Halide::Internal::GeneratorParamBase::fail_wrong_type | ( | const char * | type | ) |

protected

References GeneratorBase.

## operator=() [1/2]

GeneratorParamBase & Halide::Internal::GeneratorParamBase::operator= | ( | const GeneratorParamBase & |  | ) |

delete

References GeneratorParamBase().

## operator=() [2/2]

GeneratorParamBase & Halide::Internal::GeneratorParamBase::operator= | ( | GeneratorParamBase && |  | ) |

delete

References GeneratorParamBase().

The documentation for this class was generated from the following file:

- src/Generator.h